﻿using System;
using System.Collections.Generic;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;

namespace ConsoleApp1
{
    class Program
    {
        static List<TcpClient> _cla15000 = new List<TcpClient>();
        static List<TcpClient> _cla15001 = new List<TcpClient>();

        static void Main(string[] args)
        {
            Thread t = new Thread(CountFunc);
            t.IsBackground = true;
            t.Start();

            bool active1 = true;
            bool active2 = true;

            if (args.Length >= 1)
            {
                if (args[0] == "1")
                {
                    active2 = false;
                }
                else if (args[0] == "2")
                {
                    active1 = false;
                }
            }

            if (active1 == true)
            {
                Thread t15000 = new Thread(acceptFunc);
                t15000.IsBackground = true;
                t15000.Start(15000);
            }

            if (active2 == true)
            {
                Thread t15001 = new Thread(acceptFunc);
                t15001.IsBackground = true;
                t15001.Start(15001);
            }

            Console.ReadLine();
        }

        private static void acceptFunc(object objPort)
        {
            int port = (int)objPort;

            TcpListener svr = new TcpListener(IPAddress.Any, port);
            {
                svr.Start();

                while (true)
                {
                    TcpClient client = svr.AcceptTcpClient();

                    if (port == 15000)
                    {
                        _cla15000.Add(client);
                    }
                    else
                    {
                        _cla15001.Add(client);
                    }

                    byte [] buf = Encoding.UTF8.GetBytes($"{port}: Hello");
                    client.GetStream().Write(buf, 0, buf.Length);
                }
            }
        }

        private static void CountFunc()
        {
            while (true)
            {
                Console.WriteLine($"# of 15000: {_cla15000.Count}, 15001: {_cla15001.Count}");
                Thread.Sleep(1000);
            }
        }
    }
}
