﻿using System;
using System.Net;
using System.Net.Sockets;

namespace ConsoleApp3
{
    class Program
    {
        static void Main(string[] args)
        {
            int localPort = 1024;

            if (args.Length >= 1)
            {
                localPort = int.Parse(args[0]);
            }

            using (var socket1 = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp))
            using (var socket2 = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp))
            {
                socket1.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReuseAddress, true);
                socket1.Bind(new IPEndPoint(IPAddress.Any, localPort));
                socket1.Connect("127.0.0.1", 15000);

                Console.WriteLine($"{socket1.LocalEndPoint}-{socket1.RemoteEndPoint}");

                socket2.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReuseAddress, true);
                socket2.Bind(new IPEndPoint(IPAddress.Any, localPort));
                socket2.Connect("127.0.0.1", 15001);

                Console.WriteLine($"{socket2.LocalEndPoint}-{socket2.RemoteEndPoint}");

                Console.ReadLine();
            }
        }
    }
}
